%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014-2015 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

%
% CauchyDistribution.m
%
classdef CauchyDistribution < TLocationScaleDistribution

  methods (Access = public)

    function this = CauchyDistribution(mean, variance, dim)
      if nargin < 3
        dim = 1;
      end
      this = this@TLocationScaleDistribution(mean, variance, 1, dim);
    end

    function result = LogPdf(this, x)
      sigma = sqrt(this.Variance);
      xnorm = (x - this.Mean) / sigma;
      result = sum(-log(sigma * pi * (1 + xnorm .^ 2)), 2);
    end

  end

end
