%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html
%
% Copyright (C) 2014-2015 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori
%
% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

classdef (Abstract) IterationStrategy < handle

  properties (GetAccess = protected, SetAccess = private)
    algorithm
    mcdcStrategy
    stateModel
    obsModel
    likelihoodCalculator
    stateNoise
    obsNoise
    numDraw
  end

  methods (Access = public, Abstract)

    ProcessIteration(this, j, in, out, aspect, gridData)

  end

  methods (Access = public)

    function SetUp( ...
        this, ...
        algorithm, ...
        mcdcStrategy, ...
        stateModel, ...
        obsModel, ...
        likelihoodCalculator, ...
        stateNoise, ...
        obsNoise, ...
        numDraw ...
    )
      this.algorithm = algorithm;
      this.mcdcStrategy = mcdcStrategy;
      this.stateModel = stateModel;
      this.obsModel = obsModel;
      this.likelihoodCalculator = likelihoodCalculator;
      this.stateNoise = stateNoise;
      this.obsNoise = obsNoise;
      this.numDraw = numDraw;
    end

  end

end
