%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014-2015 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

%
% MCDCInput.m
%
classdef MCDCInput < handle

  properties (Access = public)

    xGrids
    stateKernelGens
    obsKernelGens
    stateMeanFuncs
    obsMeanFuncs
    gridDimForGramMatrix
    stateSplineHandle
    obsSplineHandle
    x0
    xaux
    u
    z
    N
    J
    K

  end

  methods (Access = public)

    function this = MCDCInput(xGrids, ...
                              stateKernelGens, obsKernelGens, ...
                              stateMeanFuncs, obsMeanFuncs, ...
                              gridDimForGramMatrix, ...
                              stateSplineHandle, obsSplineHandle, ...
                              x0, xaux, u, z, N, J, K)
      this.xGrids = xGrids;
      this.stateKernelGens = stateKernelGens;
      this.obsKernelGens = obsKernelGens;
      this.stateMeanFuncs = stateMeanFuncs;
      this.obsMeanFuncs = obsMeanFuncs;
      this.gridDimForGramMatrix = gridDimForGramMatrix;
      this.stateSplineHandle = stateSplineHandle;
      this.obsSplineHandle = obsSplineHandle;
      this.x0 = x0;
      this.xaux = xaux;
      this.u = u;
      this.z = z;
      this.N = N;
      this.J = J;
      this.K = K;
    end

    function result = XDim(this)
      result = size(this.x0, 2);
    end

    function result = YDim(this)
      result = size(this.z, 1);
    end

    function result = T(this)
      result = size(this.z, 2);
    end

  end

end
