%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014-2015 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.o

%
% TruncatedDistribution.m
%
classdef TruncatedDistribution < ContinuousUnivariateDistribution

  properties (SetAccess = private)
    SourceDistribution
    LowerBound
    UpperBound
  end

  methods (Access = public)

    function this = TruncatedDistribution(distribution, lb, ub)
      this = this@ContinuousUnivariateDistribution( ...
          truncate(distribution.dist, lb, ub), ...
          distribution.dim);

      this.SourceDistribution = distribution;
      this.LowerBound = lb;
      this.UpperBound = ub;
    end

  end

end
