%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014-2015 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

%
% Kitagawa system, generate new observations from given states
%

function y = KitagawaModelObservation(x, d1, d2, d3, d4, r)
  y = [ ...
    d1*x(:,1).^2 + d2*x(:,2).^2, ...
    d3*x(:,1).^2               , ...
                   d4*x(:,2)     ...
  ] + sqrt(r) * randn(size(x, 1), 3);
end
