%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

%
% Cycle_Regression.m
%

%%% Initialization

addpath('../');
rng('shuffle');

%%% Generate test models

% X = {};
% Y = {};
% V = {};
% W = {};
% for n = 1:10
%   cycle = Cycle();
%   [x, y, v, w] = cycle.generate(70 + n * 5);
%   X{end+1} = x;
%   Y{end+1} = y;
%   V{end+1} = v;
%   W{end+1} = w;
%   clear cycle x y v w;
% end
% clear n;
load('Cycle_10sequences_2.mat');

%%% Setting for regression

if ~exist('mcdcMatFile')
  mcdcMatFile = '../logs/Cycle_PMCMC_MultipleKnownSequences_100000.mat';
end
q = 1;
r = 1;
N = 1000;
predictT = 10;
predictU = [];

%%% Regression

EstS = {};
EstO = {};
EstLLH = {};
EstY = {};
PF = {};
for n = 1:10
  particleFilter = ParticleFilter( ...
      rand(N, 1) * 2 * pi, ...
      [], ...
      [], ...
      Y{n}(1:end-predictT), ...
      q, ...
      r, ...
      N, ...
      0);
  [FnState, FnObs, logLH, y] = MCDCRegression( ...
      particleFilter, ...
      predictT, ...
      predictU, ...
      mcdcMatFile);
  EstS{end+1} = FnState;
  EstO{end+1} = FnObs;
  EstLLH{end+1} = logLH;
  EstY{end+1} = y;
  PF{end+1} = particleFilter;
  clear particleFilter FnState FnObs logLH y;
end
clear n;

save('../logs/Cycle_Regression.mat');
