%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

%
% NonLinearSSM_Regression.m
%

%%% Initialization

addpath('../');
rng('shuffle');

%%% Generate sequences for test

ssm = NonLinearSSM();
[X, Y, V, W] = ssm.generate(100);

%%% Load trained model

if ~exist('modelFile')
  modelFile = '../logs/NonLinearSSM_PMCMC2_100.mat';
end

%%% Regression

x0 = 0;
xaux = [];
u = [0; 8 * cos(1.2 * [2:100])'];
q = 1;
r = 0.1;
N = 1000;

T = 10;
particleFilter = ParticleFilter( ...
    x0, ...
    xaux', ...
    u(1:end-T), ...
    Y(1:end-T), ...
    q, ...
    r, ...
    N, ...
    0);
[FnState, FnObs, logLH, y] = MCDCRegression( ...
    particleFilter, ...
    T, ...
    u(end-T+1:end), ...
    modelFile);

save('../logs/NonLinearSSM_Regression.mat');
